with Ada.Text_IO, Reps, Intervals, Intervals.Ops, Intervals.IO, Fouriers_Init;
use Ada.Text_IO, Reps, Intervals, Intervals.Ops, Intervals.IO, Fouriers_Init;
pragma Elaborate_All(Intervals.Ops, Intervals.IO);

procedure RG_Param is

  Sigma: constant Rep := 0.85001;
  Kappa: constant Rep := Sigma/0.4;
  RBall: constant Radius := 3.0E-12;         -- for contraction MM

  R:  constant Weights := (0.85,0.15);       -- for domain of RG
  Rpp: constant Weights := (0.90,0.165);     -- for domain of NN

  O: constant Interval := Scal(Zero);

  Rs: Weights;

  procedure Show(S: in String; R: in Rep; Decimal: in Boolean := False) is
  begin
    Put(S);
    Put(Current_Output,Scal(R),Decimal);
    New_Line;
  end Show;

begin

  Rs := (Up(R.Q,O),Up(R.P,O));                -- for range of RG

  Show("  Sigma = ",Sigma);
  Show("  Kappa = ",Kappa);
  Show("      r = ",RBall);
  Show("  Rho_1 = ",R.Q);
  Show("  Rho_2 = ",R.P);
  Show("Rho^*_1 = ",Rs.Q);
  Show("Rho^*_2 = ",Rs.P);
  Show("Rho''_1 = ",Rpp.Q);
  Show("Rho''_2 = ",Rpp.P);

end RG_Param;
